// ---------------------------------------------------------------------------
//	M88 - PC-8801 Emulator
//	Copyright (C) cisc 1998, 2001.
// ---------------------------------------------------------------------------
//	$Id: joypad.cpp,v 1.1 2002/04/07 05:40:09 cisc Exp $

#include "headers.h"
#include "joypad.h"
#include "if/ifguid.h"

using namespace PC8801;

// ---------------------------------------------------------------------------
//	\zEj
//
JoyPad::JoyPad()
: Device(0), ui(0)
{
}

JoyPad::~JoyPad()
{
}

// ---------------------------------------------------------------------------
//
//
bool JoyPad::Connect(IUnk* unk)
{
	RELEASE(ui);
	if (unk)
		unk->QueryInterface(ChIID_PadInput, (void**) &ui);
	return !!ui;
}

// ---------------------------------------------------------------------------
//	
//
uint IOCALL JoyPad::GetDirection(uint)
{
	if (!paravalid)
		Update();
	return data[0];
}

uint IOCALL JoyPad::GetButton(uint)
{
	if (!paravalid)
		Update();
	return data[1];
}

void JoyPad::Update()
{
	PadState ps;
	if (ui)
	{
		ui->GetState(&ps);
		data[0] = ~ps.direction | 0xf0;
		data[1] = ~ps.button | 0xfc;
	}
	else
	{
		data[0] = data[1] = 0xff;
	}
	paravalid = true;
}

// ---------------------------------------------------------------------------
//	VSync ݂
//
void IOCALL JoyPad::VSync(uint, uint d)
{
	if (d)
		paravalid = false;
}
	
// ---------------------------------------------------------------------------
//	device description
//
const Device::Descriptor JoyPad::descriptor = { indef, outdef };

const Device::OutFuncPtr JoyPad::outdef[] = 
{
	STATIC_CAST(Device::OutFuncPtr, VSync),
};

const Device::InFuncPtr JoyPad::indef[] = 
{
	STATIC_CAST(Device::InFuncPtr, GetDirection),
	STATIC_CAST(Device::InFuncPtr, GetButton),
};

