// ---------------------------------------------------------------------------
//	M88 - PC-8801 Emulator
//	Copyright (C) cisc 1998, 1999.
// ---------------------------------------------------------------------------
//	$Id: joypad.h,v 1.1 2002/04/07 05:40:09 cisc Exp $

#if !defined(pc88_joypad_h)
#define pc88_joypad_h

#include "device.h"
#include "if/ifui.h"

namespace PC8801
{

class JoyPad : public Device  
{
public:
	enum
	{
		vsync = 0,
		getdir = 0, getbutton = 1,
	};

public:
	JoyPad();
	~JoyPad();

	bool Connect(IUnk* ui);
	const Descriptor* IFCALL GetDesc() const { return &descriptor; } 
	
	void IOCALL Reset() {}
	uint IOCALL GetDirection(uint port);
	uint IOCALL GetButton(uint port);
	void IOCALL VSync(uint=0, uint=0);

private:
	void Update();

	IPadInput* ui;
	bool paravalid;
	uint8 data[2];

private:
	static const Descriptor descriptor;
	static const InFuncPtr indef[];
	static const OutFuncPtr outdef[];
};

}

#endif // !defined(pc88_joypad_h)
