// ---------------------------------------------------------------------------
//	M88 - PC-88 Emulator
//	Copyright (C) cisc 1997, 2001.
// ---------------------------------------------------------------------------
//	Sound Implemention for Win32
// ---------------------------------------------------------------------------
//	$Id: winsound.h,v 1.16 2002/05/31 09:45:22 cisc Exp $

#if !defined(win32_winsound_h)
#define win32_winsound_h

#include "types.h"
#include "pc88/sound.h"
#include "sounddrv.h"
#include "critsect.h"

class PC88;
class OPNMonitor;

namespace PC8801
{
class Config;

class WinSound : public Sound
{
	enum DumpState
	{
		idle, standby, dumping
	};

public:
	WinSound();
	~WinSound();

	bool Init(PC88* pc, HWND hwnd, uint rate, uint buflen);
	bool ChangeRate(uint rate, uint buflen, bool wo);
	
	void ApplyConfig(const Config* config);

	bool DumpBegin(char* filename);
	bool DumpEnd();
	bool IsDumping() { return dumpstate != idle; }

	void SetSoundMonitor(OPNMonitor* mon) { soundmon = mon; }
	
private:
	bool InitSoundBuffer(LPDIRECTSOUND lpds, uint rate);
	void Cleanup();
	int Get(Sample* dest, int samples);
	void Dump(Sample* dest, int samples);

	WinSoundDriver::Driver* driver;
	
	HWND hwnd;
	uint currentrate;
	uint currentbuflen;
	uint samprate;
	
	HMMIO hmmio;					// mmio handle
	MMCKINFO ckparent;				// RIFF `N
	MMCKINFO ckdata;				// data `N

	CriticalSection cs;

	OPNMonitor* soundmon;
	DumpState dumpstate;
	int dumpedsample;
	bool wodrv;
	bool useds2;
};

}

#endif // !defined(win32_winsound_h)
